unit UIntQueue;

interface
  Uses
    SysUtils, UQueue;
  const
    N=100;
  type
    //TElem = integer;
    TElem = pointer;
    TMas=array[0..N-1] of TElem;

  TIntQueue = class(TQueue)
  protected
    function ElemToStr(el : Pointer) : string; override;
    procedure DelElem(el : Pointer); override;
  public
    class function CheckElem(el : pointer) : boolean; override;
    class function TryStrToElem(word : string; var p : pointer) : boolean; override;
  end;

implementation
{TIntQueue}
function TIntQueue.ElemToStr(el: Pointer) : string;
var
  tmp : integer;
begin
  tmp := Integer(el);
  Result := IntToStr(tmp);
end;

class function TIntQueue.CheckElem(el : pointer) : boolean;
begin
  Result := odd(Integer(el));
end;

class function TIntQueue.TryStrToElem(word : string; var p : pointer) : boolean;
var
  tmp : integer;
  ptmp : ^integer;
begin
  Result := TryStrToInt(word, tmp);
  if Result then
    try
      //new(ptmp);
      //ptmp^ := tmp;
      //p := ptmp;
      p:=pointer(tmp)
    except
      raise Exception.Create('Unknown Error');
    end;
end;

procedure TIntQueue.DelElem(el: Pointer);
var
  ptmp : ^integer;
begin
{  inherited;
  ptmp:=el;
  dispose(ptmp);}
end;

end.
