unit UStrQueue;

interface
  Uses
    SysUtils, UQueue;
  const
    N=100;
  type
    //TElem = string;
    TElem = pointer;
    TMas=array[0..N-1] of TElem;

  TStrQueue = class(TQueue)
  protected
    function ElemToStr(el : Pointer) : string; override;
    procedure DelElem(el : Pointer); override;
  public
    class function CheckElem(el : pointer) : boolean; override;
    class function TryStrToElem(word : string; var p : pointer) : boolean; override;
  end;

implementation
{TIntQueue}
function TStrQueue.ElemToStr(el: Pointer) : string;
begin
  Result := String(el^);
end;

class function TStrQueue.CheckElem(el : pointer) : boolean;
//debug
var
  temp : string;
  tmp : integer;
begin
  temp := String(el^);
  tmp := length(temp);
//  Result := odd(length(String(el^)));
  Result := odd(tmp);
end;

class function TStrQueue.TryStrToElem(word : string; var p : pointer) : boolean;
var
  ps : ^String;
begin
  Result := false;
  try
    new(ps);
    ps^ := word;
    p := ps;
    Result := true;
  except
    raise Exception.Create('Unknown Error');
  end;
end;


procedure TStrQueue.DelElem(el: Pointer);
var
  ps : ^String;
begin
  inherited;
  ps:=el;
  dispose(ps);
end;

end.
